// }[JF̈̒o

#include <iostream>
#include <opencv2/opencv.hpp>

#include "cv_lib_macro.h"

#pragma CV_LIBRARY(core)
#pragma CV_LIBRARY(imgproc)
#pragma CV_LIBRARY(highgui)

using namespace cv;
using namespace std;

int main(void)
{
	char *window_input = "input";
	namedWindow(window_input, CV_WINDOW_AUTOSIZE);

	char *window_hue = "hue";
	namedWindow(window_hue, CV_WINDOW_AUTOSIZE);

	char *window_saturation = "saturation";
	namedWindow(window_saturation, CV_WINDOW_AUTOSIZE);

	char *window_value = "value";
	namedWindow(window_value, CV_WINDOW_AUTOSIZE);

	char *window_result = "result";
	namedWindow(window_result, CV_WINDOW_AUTOSIZE);

	int hue_min = 0;
	int hue_max = 179;
	int saturation_min = 0;
	int saturation_max = 255;
	int value_min = 0;
	int value_max = 255;

	createTrackbar("H min", "result", &hue_min, 179);
	createTrackbar("H max", "result", &hue_max, 179);
	createTrackbar("S min", "result", &saturation_min, 255);
	createTrackbar("S max", "result", &saturation_max, 255);
	createTrackbar("V min", "result", &value_min, 255);
	createTrackbar("V max", "result", &value_max, 255);

	VideoCapture cap;
	cap.open(0);
	if (!cap.isOpened()) {
		cerr << "cannot find camera" << endl;
		return -1;
	}

	while (1) {
		Mat frame;
		cap >> frame;

		Mat frame_hsv;
		/* frame (BGRF)  frame_hsv (HSVF) ɕϊ  */
		cvtColor(frame, frame_hsv, CV_BGR2HSV);

		Mat channels[3];
		/* frame_hsv ̊e`l(ꂼh,s,v̒li[Ă)
		   channels[0], channels[1], channels[2] ɕ*/
		split(frame_hsv, channels);

		Mat binarized[3];
		/* h,s,vꂼɏƉ݂ēl */
		
		// hue
		inRange(channels[0], hue_min, hue_max, binarized[0]);
		// saturation
		inRange(channels[1], saturation_min, saturation_max, binarized[1]);
		// value
		inRange(channels[2], value_min, value_max, binarized[2]);

		Mat marker;
		/* h,s,vׂ̂Ă̏𖞂̈悪}[J(_ς) */
		marker = binarized[0] & binarized[1] & binarized[2];

		Mat denoise;
		/* TO-DO: ňȉ̏s悤ɂD

		   1-25߂̃\[XR[hQlɂāC
		   摜markermCY摜 denoise D
		   5.1̃tHWtB^C5.2̃fBAtB^C
		   ꂩЕgpD*/
		   
		Mat edge;
		/* TO-DO: ňȉ̏s悤ɂD

		   1-26߂̃\[XR[hQlɂāC
		   摜 denoise GbW𒊏o摜 edge D
		   Canny̑3C4(臒l)́C50150ɐݒ肵Ă݂D*/

		vector<Vec2f> lines;
		/* TO-DO: ňȉ̏s悤ɂD

		   1-27߂̃\[XR[hQlɂāC
		   摜 edge ̒o lines Ɋi[D

		   o`悷D7߂̃\[XR[hQlɂ΂悢C
		   `悷֐ line ̑1`Ώۉ摜ɂ_
		   ύXKvłD*/

		/* TO-DO: Œ̌_̌osD */
		
		/* e摜̕\ */
		imshow(window_input, frame);

		imshow(window_hue, binarized[0]);
		imshow(window_saturation, binarized[1]);
		imshow(window_value, binarized[2]);

		imshow(window_result, marker);

		/* L[͂̃`FbND
		   ꂪƃEBhEɉ摜oȂꍇD*/
		int key = waitKey(10);
		if (key == 3 || key == 27 || key == 'q') {
			break;
		}
	}

	return 0;
}
