// cv_lib_macro.h

#ifndef CV_LIB_MACRO_H_
#define CV_LIB_MACRO_H_

#define CV_LIB_PREFIX comment(lib, "opencv_"

#define CV_LIB_VERSION CVAUX_STR(CV_MAJOR_VERSION)\
  CVAUX_STR(CV_MINOR_VERSION)\
  CVAUX_STR(CV_SUBMINOR_VERSION)

#ifdef _DEBUG
#define CV_LIB_SUFFIX "d.lib")
#else
#define CV_LIB_SUFFIX ".lib")
#endif

#define CV_LIBRARY(lib_name) CV_LIB_PREFIX CVAUX_STR(lib_name) CV_LIB_VERSION CV_LIB_SUFFIX

#define LIB_PREFIX comment(lib,
#define WIN32_LIB_SUFFIX ".lib")

#define OTHER_LIBRARY(lib_name) LIB_PREFIX #lib_name CV_LIB_SUFFIX
#define WIN32_LIBRARY(lib_name) LIB_PREFIX #lib_name WIN32_LIB_SUFFIX

#pragma OTHER_LIBRARY(libjasper)
#pragma OTHER_LIBRARY(libjpeg)
#pragma OTHER_LIBRARY(libpng)
#pragma OTHER_LIBRARY(libtiff)
#pragma OTHER_LIBRARY(zlib)

#pragma WIN32_LIBRARY(comctl32)
#pragma WIN32_LIBRARY(vfw32)

#endif // CV_LIB_MACRO_H_
